package mathematique;

import javax.swing.*;
import java.awt.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Additionskarteikarte extends Eingabekarteikarte {
    JPanel panEingabeDaten = new JPanel();
    JTextField txtA = new JTextField();
    JLabel lblOperator = new JLabel();
    JTextField txtB = new JTextField();
    GridBagLayout gridBagLayout1 = new GridBagLayout();

    /** Wird zur Berechnung bentigt. */
    private double a, b, ergebnis;

    /** Stellt Rechnung grafisch als Balken dar. */
    JLabel grafik = new JLabel() {

      // Setzen der bevorzugten Gre des Zeichenfeldes.
      // 0, 0 bedeutet keine bevorzugte Gre.
      // 200, 200 bedeutet, das die ScrollPane dafr sorgt, das die
      // Grafik mindestens 200, 200 gro ist und bei bedarf gescrollt wird.
      { this.setPreferredSize(new Dimension(400,400));}

      // Die halbe Balkenbreite
      final static int barHalfWidth = 10;

      private double betrag(double x) {
        return (x >= 0)? x : -x;
      }

      // Zeichnen des Grafen
      public void paintComponent(Graphics g) {

        // Nur bei Verwendung von Swing Komponenten!
        Graphics2D g2 = (Graphics2D) g;

        // Breite des Zeichenfeldes.
        int sizeX = this.getSize().width;
        // Hhe des Zeichenfeldes.
        int sizeY = this.getSize().height;

        // Maximum der Ein und Ausgabedaten berechen.
        double max = (betrag(a) > betrag(b)) ? a : b;
        max = (betrag(max) > betrag(ergebnis)) ? max : ergebnis;
        max = betrag(max);
        double scale = sizeY/ 2 / max;

        // Variablen fr die Koordinatenumrechnung
        int height = 0;
        int ypos = 0;

        // Linie in der Mitte des Zeichenfeldes
        g2.drawLine(0,sizeY/2, sizeX, sizeY/2);

        // Berechnen der absoluten Hhe und der y Position des 1. Balkens
        height = (int) (a * scale);
        height = (height > 0 )? height : -height;
        ypos = (a>0)? sizeY/2 - height : sizeY/2;
        // Zeichnen des Balkens.
        g2.setPaint(Color.green);
        g2.fillRect(sizeX/4 - barHalfWidth, ypos , barHalfWidth*2, height);
        g2.setPaint(Color.black);
        g2.drawString("" + a, sizeX/4 + barHalfWidth + 2, ypos + 14);

        // Berechnen der absoluten Hhe und der y Position des 2. Balkens
        height = (int) (b * scale);
        height = (height > 0 )? height : -height;
        ypos = (b>0)? sizeY/2 - height : sizeY/2;
        // Zeichnen des Balkens.
        g2.setPaint(Color.green);
        g2.fillRect(sizeX/2 - barHalfWidth, ypos, barHalfWidth*2, height);
        g2.setPaint(Color.black);
        g2.drawString("" + b, sizeX/2 + barHalfWidth + 2, ypos + 14);

        // Berechnen der absoluten Hhe und der y Position des 3. Balkens
        height = (int) (ergebnis * scale);
        height = (height > 0 )? height : -height;
        ypos = (ergebnis>0)? sizeY/2 - height : sizeY/2;
        // Zeichnen des Balkens.
        g2.setPaint(Color.red);
        g2.fillRect(sizeX/4*3 - barHalfWidth, ypos, barHalfWidth*2, height);
        g2.setPaint(Color.black);
        g2.drawString("" + ergebnis, sizeX/4*3 + barHalfWidth + 2, ypos + 14);

      }
    };

    public Additionskarteikarte() {
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    /** Berechne aus den eingegebenen Werten das Ergebnis. Nach dem Aufruf dieser
     *  Methode wird die Ausgabe angezeigt, die sich die Ergebnisse/ Informationen
     *  aus getInformation(), getErgebnis() und getGrafik() holt.
     */
    public void rechne() {
            a = (new Double(txtA.getText())).doubleValue();
            b = (new Double(txtB.getText())).doubleValue();
            ergebnis = a + b;
    }

    /** Liefert den Text, der als Information in der Ausgabe gezeigt werden soll. */
    public String getInformation() {
            return "Die Addition zweier Zahlen";
    }

    /** Liefert den Text, der als Ergebnis angezeigt werden soll. */
    public String getErgebnis() {
      return a + " + " + b + " = " + ergebnis;
    }

    /** Liefert die Komponente, die zur Anzeige der Grafik verwendet werden soll. */
    public Component getGrafik() {
      return grafik;
    }

    void jbInit() throws Exception {
        panEingabeDaten.setLayout(gridBagLayout1);
        lblOperator.setHorizontalAlignment(SwingConstants.CENTER);
        lblOperator.setText("+");
        txtA.setHorizontalAlignment(SwingConstants.RIGHT);
        txtB.setHorizontalAlignment(SwingConstants.RIGHT);
        this.add(panEingabeDaten, BorderLayout.CENTER);
        panEingabeDaten.add(txtA, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
        panEingabeDaten.add(lblOperator, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(5, 15, 5, 15), 0, 0));
        panEingabeDaten.add(txtB, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    }
}